summaryrefslogtreecommitdiffstats
path: root/package/uhttpd/files
diff options
context:
space:
mode:
authorjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-03-25 15:46:16 +0000
committerjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-03-25 15:46:16 +0000
commit56d71638dbf48b8e4885e1e5ed5d0f1859674541 (patch)
tree09271ae71406b7b3c559d8ee5aa6561ce06e65f9 /package/uhttpd/files
parent668888c026b7ba26c4ae8b35fbd25966b2685448 (diff)
[package] add uhttpd (moved from LuCI trunk)
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@20428 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/uhttpd/files')
-rw-r--r--package/uhttpd/files/uhttpd.config53
-rwxr-xr-xpackage/uhttpd/files/uhttpd.init115
2 files changed, 168 insertions, 0 deletions
diff --git a/package/uhttpd/files/uhttpd.config b/package/uhttpd/files/uhttpd.config
new file mode 100644
index 000000000..0bca4f516
--- /dev/null
+++ b/package/uhttpd/files/uhttpd.config
@@ -0,0 +1,53 @@
+# Server configuration
+config uhttpd main
+
+ # Server document root
+ option home /www
+
+ # Certificate and private key for HTTPS.
+ # If no listen_https addresses are given,
+ # the key options are ignored.
+ option cert /etc/uhttpd.crt
+ option key /etc/uhttpd.key
+
+ # CGI url prefix, will be searched in docroot.
+ # Default is /cgi-bin
+ option cgi_prefix /cgi-bin
+
+ # Lua url prefix and handler script.
+ # Lua support is disabled if no prefix given.
+# option lua_prefix /luci
+# option lua_handler /usr/lib/lua/luci/sgi/uhttpd.lua
+
+ # HTTP listen addresses, multiple allowed
+ list listen_http 0.0.0.0:80
+# list listen_http [::]:80
+
+ # HTTPS listen addresses, multiple allowed
+ list listen_https 0.0.0.0:443
+# list listen_https [::]:443
+
+ # Basic auth realm, defaults to local hostname
+# option realm OpenWrt
+
+ # Configuration file in busybox httpd format
+# option config /etc/httpd.conf
+
+
+# Certificate defaults for px5g key generator
+config cert px5g
+
+ # Validity time
+ option days 730
+
+ # RSA key size
+ option bits 1024
+
+ # Location
+ option country DE
+ option state Berlin
+ option location Berlin
+
+ # Common name
+ option commonname OpenWrt
+
diff --git a/package/uhttpd/files/uhttpd.init b/package/uhttpd/files/uhttpd.init
new file mode 100755
index 000000000..a25bf789c
--- /dev/null
+++ b/package/uhttpd/files/uhttpd.init
@@ -0,0 +1,115 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2010 Jo-Philipp Wich
+
+START=50
+UHTTPD_BIN="/usr/sbin/uhttpd"
+PX5G_BIN="/usr/sbin/px5g"
+
+
+append_listen_http() {
+ append UHTTPD_ARGS "-p $1"
+}
+
+append_listen_https() {
+ append UHTTPD_ARGS "-s $1"
+}
+
+append_arg() {
+ local cfg="$1"
+ local var="$2"
+ local opt="$3"
+ local def="$4"
+ local val
+
+ config_get val "$cfg" "$var"
+ [ -n "$val" -o -n "$def" ] && append UHTTPD_ARGS "$opt ${val:-$def}"
+}
+
+generate_keys() {
+ local cfg="$1"
+ local key="$2"
+ local crt="$3"
+ local days bits country state location commonname
+
+ config_get days "$cfg" days
+ config_get bits "$cfg" bits
+ config_get country "$cfg" country
+ config_get state "$cfg" state
+ config_get location "$cfg" location
+ config_get commonname "$cfg" commonname
+
+ [ -x "$PX5G_BIN" ] && {
+ $PX5G_BIN selfsigned -der \
+ -days ${days:-730} -newkey rsa:${bits:-1024} -keyout "$UHTTPD_KEY" -out "$UHTTPD_CERT" \
+ -subj /C=${country:-DE}/ST=${state:-Saxony}/L=${location:-Leipzig}/CN=${commonname:-OpenWrt}
+ } || {
+ echo "WARNING: the specified certificate and key" \
+ "files do not exist and the px5g generator" \
+ "is not available, skipping SSL setup."
+ }
+}
+
+start_instance()
+{
+ UHTTPD_ARGS=""
+ UHTTPD_CERT=""
+ UHTTPD_KEY=""
+
+ local cfg="$1"
+ local realm="$(uci get system.@system[0].hostname 2>/dev/null)"
+ local ssl
+
+ append_arg "$cfg" home "-h"
+ append_arg "$cfg" realm "-r" "${realm:-OpenWrt}"
+ append_arg "$cfg" config "-c"
+ append_arg "$cfg" cgi_prefix "-x"
+ append_arg "$cfg" lua_prefix "-l"
+ append_arg "$cfg" lua_handler "-L"
+
+ config_list_foreach "$cfg" listen_http \
+ append_listen_http
+
+ config_get ssl "$cfg" listen_https
+ config_get UHTTPD_KEY "$cfg" key /etc/uhttpd.key
+ config_get UHTTPD_CERT "$cfg" cert /etc/uhttpd.crt
+
+ [ -n "$ssl" ] && {
+ [ -f "$UHTTPD_CERT" -a -f "$UHTTPD_KEY" ] || {
+ config_foreach generate_keys cert
+ }
+
+ [ -f "$UHTTPD_CERT" -a -f "$UHTTPD_KEY" ] && {
+ append_arg "$cfg" cert "-C"
+ append_arg "$cfg" key "-K"
+
+ config_list_foreach "$cfg" listen_https \
+ append_listen_https
+ }
+ }
+
+ start-stop-daemon -S -x $UHTTPD_BIN \
+ -p /var/run/uhttpd_${cfg}.pid \
+ -m -b -- -f $UHTTPD_ARGS
+}
+
+stop_instance()
+{
+ local cfg="$1"
+
+ [ -f /var/run/uhttpd_${cfg}.pid ] && {
+ start-stop-daemon -K -q -n ${UHTTPD_BIN##*/} \
+ -p /var/run/uhttpd_${cfg}.pid -s TERM
+
+ rm -f /var/run/uhttpd_${cfg}.pid
+ }
+}
+
+start() {
+ config_load uhttpd
+ config_foreach start_instance uhttpd
+}
+
+stop() {
+ config_load uhttpd
+ config_foreach stop_instance uhttpd
+}